## busybox 1.37.0

=== Makefile ===
VERSION = 1
PATCHLEVEL = 37
SUBLEVEL = 0
EXTRAVERSION =
NAME = Unnamed

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

# Do not print "Entering directory ..."
MAKEFLAGS += --no-print-directory

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.o targets which finally
# turn into busybox), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifdef V
  ifeq ("$(origin V)", "command line")
    KBUILD_VERBOSE = $(V)
  endif
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

# Call sparse as part of compilation of C files
# Use 'make C=1' to enable sparse checking

ifdef C
  ifeq ("$(origin C)", "command line")
    KBUILD_CHECKSRC = $(C)
  endif
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

# Use make M=dir to specify directory of external module to build
# Old syntax make ... SUBDIRS=$PWD is still supported
# Setting the environment variable KBUILD_EXTMOD take precedence
ifdef SUBDIRS
  KBUILD_EXTMOD ?= $(SUBDIRS)
endif
ifdef M
  ifeq ("$(origin M)", "command line")
    KBUILD_EXTMOD := $(M)
  endif
endif


# kbuild supports saving output files in a separate directory.
# To locate output files in a separate directory two syntaxes are supported.
# In both cases the working directory must be the root of the kernel src.
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the directory
# where the output files shall be placed.
# export KBUILD_OUTPUT=dir/to/store/output/files/
# make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.


# KBUILD_SRC is set on invocation of make in OBJ directory
# KBUILD_SRC is not intended to be used by the regular user (for now)
ifeq ($(KBUILD_SRC),)

# OK, Make called in directory where kernel src resides
# Do we want to locate output files in a separate directory?
ifdef O
  ifeq ("$(origin O)", "command line")
    KBUILD_OUTPUT := $(O)
  endif
endif

# That's our default target when none is given on the command line
PHONY := _all
_all:

ifneq ($(KBUILD_OUTPUT),)
# Invoke a second make in the output directory, passing relevant variables
# check that the output directory actually exists
saved-output := $(KBUILD_OUTPUT)
KBUILD_OUTPUT := $(shell cd $(KBUILD_OUTPUT) && /bin/pwd)
$(if $(KBUILD_OUTPUT),, \
     $(error output directory "$(saved-output)" does not exist))

PHONY += $(MAKECMDGOALS)

$(filter-out _all,$(MAKECMDGOALS)) _all:
	$(if $(KBUILD_VERBOSE:1=),@)$(MAKE) -C $(KBUILD_OUTPUT) \
	KBUILD_SRC=$(CURDIR) \
	KBUILD_EXTMOD="$(KBUILD_EXTMOD)" -f $(CURDIR)/Makefile $@

# Leave processing to above invocation of make
skip-makefile := 1
endif # ifneq ($(KBUILD_OUTPUT),)
endif # ifeq ($(KBUILD_SRC),)

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

# If building an external module we do not care about the all: rule
# but instead _all depend on modules
PHONY += all
ifeq ($(KBUILD_EXTMOD),)
_all: all
else
_all: modules
endif

srctree		:= $(if $(KBUILD_SRC),$(KBUILD_SRC),$(CURDIR))
TOPDIR		:= $(srctree)
# FIXME - TOPDIR is obsolete, use srctree/objtree
objtree		:= $(CURDIR)
src		:= $(srctree)
obj		:= $(objtree)

VPATH		:= $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))

export srctree objtree VPATH TOPDIR


# Cross compiling and selecting different set of gcc/bin-utils
# ---------------------------------------------------------------------------
#
# When performing cross compilation for other architectures ARCH shall be set
# to the target architecture. (See arch/* for the possibilities).
# ARCH can be set during invocation of make:
# make ARCH=ia64
# Another way is to have ARCH set in the environment.
# The default ARCH is the host where make is executed.

# CROSS_COMPILE specify the prefix used for all executables used
# during compilation. Only gcc and related bin-utils executables
# are prefixed with $(CROSS_COMPILE).
# CROSS_COMPILE can be set on the command line
# make CROSS_COMPILE=ia64-linux-
# Alternatively CROSS_COMPILE can be set in the environment.
# Default value for CROSS_COMPILE is not to prefix executables
# Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile

CROSS_COMPILE ?=
# bbox: we may have CONFIG_CROSS_COMPILER_PREFIX in .config,
# and it has not been included yet... thus using an awkward syntax.
ifeq ($(CROSS_COMPILE),)
CROSS_COMPILE := $(shell grep ^CONFIG_CROSS_COMPILER_PREFIX .config 2>/dev/null)
CROSS_COMPILE := $(subst CONFIG_CROSS_COMPILER_PREFIX=,,$(CROSS_COMPILE))
CROSS_COMPILE := $(subst ",,$(CROSS_COMPILE))
#")
endif

# SUBARCH tells the usermode build what the underlying arch is.  That is set
# first, and if a usermode build is happening, the "ARCH=um" on the command
# line overrides the setting of ARCH below.  If a native build is happening,
# then ARCH is assigned, getting whatever value it gets normally, and
# SUBARCH is subsequently ignored.

ifneq ($(CROSS_COMPILE),)
SUBARCH := $(shell echo $(CROSS_COMPILE) | cut -d- -f1 | sed 's:^.*/::g')
else
SUBARCH := $(shell uname -m)
endif
SUBARCH := $(shell echo $(SUBARCH) | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ \
					 -e s/arm.*/arm/ -e s/sa110/arm/ \
					 -e s/s390x/s390/ -e s/parisc64/parisc/ \
					 -e s/ppc.*/powerpc/ -e s/mips.*/mips/ )

ARCH ?= $(SUBARCH)

# Architecture as present in compile.h
UTS_MACHINE := $(ARCH)

# SHELL used by kbuild
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

# 	Decide whether to build built-in, modular, or both.
#	Normally, just do built-in.

KBUILD_MODULES :=
KBUILD_BUILTIN := 1

#	If we have only "make modules", don't compile built-in objects.
#	When we're building modules with modversions, we need to consider
#	the built-in objects during the descend as well, in order to
#	make sure the checksums are uptodate before we record them.

ifeq ($(MAKECMDGOALS),modules)
  KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
endif

#	If we have "make <whatever> modules", compile modules
#	in addition to whatever we do anyway.
#	Just "make" or "make all" shall build modules as well

ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
  KBUILD_MODULES := 1
endif

ifeq ($(MAKECMDGOALS),)
  KBUILD_MODULES := 1
endif

export KBUILD_MODULES KBUILD_BUILTIN
export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed.
# If it is set to "silent_", nothing wil be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(findstring s,$(MAKEFLAGS)),)
  quiet=silent_
endif

export quiet Q KBUILD_VERBOSE


# Look for make include files relative to root of kernel src
MAKEFLAGS += --include-dir=$(srctree)

HOSTCC  	= gcc
HOSTCXX  	= g++
HOSTCFLAGS	:=
HOSTCXXFLAGS	:=
# We need some generic definitions
include $(srctree)/scripts/Kbuild.include

HOSTCFLAGS	+= $(call hostcc-option,-Wall -Wstrict-prototypes -O2 -fomit-frame-pointer,)
HOSTCXXFLAGS	+= -O2

# For maximum performance (+ possibly random breakage, uncomment
# the following)

MAKEFLAGS += -rR

# Make variables (CC, etc...)

AS		= $(CROSS_COMPILE)as
CC		= $(CROSS_COMPILE)gcc
LD		= $(CC) -nostdlib
CPP		= $(CC) -E
AR		= $(CROSS_COMPILE)ar
NM		= $(CROSS_COMPILE)nm
STRIP		= $(CROSS_COMPILE)strip
OBJCOPY		= $(CROSS_COMPILE)objcopy
OBJDUMP		= $(CROSS_COMPILE)objdump
PKG_CONFIG	?= $(CROSS_COMPILE)pkg-config
AWK		= awk
GENKSYMS	= scripts/genksyms/genksyms
DEPMOD		= /sbin/depmod
KALLSYMS	= scripts/kallsyms
PERL		= perl
CHECK		= sparse

CHECKFLAGS     := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ -Wbitwise $(CF)
MODFLAGS	= -DMODULE
CFLAGS_MODULE   = $(MODFLAGS)
AFLAGS_MODULE   = $(MODFLAGS)
LDFLAGS_MODULE  = -r
CFLAGS_KERNEL	=
AFLAGS_KERNEL	=


# Use LINUXINCLUDE when you must reference the include/ directory.
# Needed to be compatible with the O= option
CFLAGS		:= $(CFLAGS)
# Added only to final link stage of busybox binary
CFLAGS_busybox	:= $(CFLAGS_busybox)
CPPFLAGS	:= $(CPPFLAGS)
AFLAGS		:= $(AFLAGS)
LDFLAGS		:= $(LDFLAGS)
LDLIBS		:=
ifeq ("${AB_CUSTOMIZE_MODIFIED}","true")
CFLAGS 		+= ${PLATFORM_CFLAGS} $(EXTRA_CFLAGS_APP)
LDFLAGS		+= $(EXTRA_LD_FLAGS_APP)
LDLIBS		+= pthread 
endif

# Read KERNELRELEASE from .kernelrelease (if it exists)
KERNELRELEASE = $(shell cat .kernelrelease 2> /dev/null)
KERNELVERSION = $(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)

export	VERSION PATCHLEVEL SUBLEVEL KERNELRELEASE KERNELVERSION \
	ARCH CONFIG_SHELL HOSTCC HOSTCFLAGS CROSS_COMPILE AS LD CC \
	CPP AR NM STRIP OBJCOPY OBJDUMP MAKE AWK GENKSYMS PERL UTS_MACHINE \
	HOSTCXX HOSTCXXFLAGS LDFLAGS_MODULE CHECK CHECKFLAGS

export CPPFLAGS NOSTDINC_FLAGS LINUXINCLUDE OBJCOPYFLAGS LDFLAGS
export CFLAGS CFLAGS_KERNEL CFLAGS_MODULE
export AFLAGS AFLAGS_KERNEL AFLAGS_MODULE
export FLTFLAGS

# When compiling out-of-tree modules, put MODVERDIR in the module
# tree rather than in the kernel tree. The kernel tree might
# even be read-only.
export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions

# Files to ignore in find ... statements

RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o -name CVS -o -name .pc -o -name .hg -o -name .git \) -prune -o
export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn --exclude CVS --exclude .pc --exclude .hg --exclude .git

# ===========================================================================
# Rules shared between *config targets and build targets

# Basic helpers built in scripts/
PHONY += scripts_basic
scripts_basic:
	$(Q)$(MAKE) $(build)=scripts/basic

# To avoid any implicit rule to kick in, define an empty command.
scripts/basic/%: scripts_basic ;

# This target generates Kbuild's and Config.in's from *.c files
PHONY += gen_build_files
gen_build_files: $(wildcard $(srctree)/*/*.c) $(wildcard $(srctree)/*/*/*.c) $(wildcard $(srctree)/embed/*)
	$(Q)$(srctree)/scripts/gen_build_files.sh $(srctree) $(objtree)

# bbox: we have helpers in applets/
# we depend on scripts_basic, since scripts/basic/fixdep
# must be built before any other host prog
PHONY += applets_dir
applets_dir: scripts_basic gen_build_files include/config/MARKER
	$(Q)$(MAKE) $(build)=applets

applets/%: applets_dir ;

=== debian/changelog ===
busybox (1:1.37.0-7) unstable; urgency=medium

  * patches/archival-disallow-path-traversals-CVE-2023-39810.patch
    (Closes: #1055307, CVE-2023-39810)
  * archival-disallow-path-traversals-CVE-2023-39810.patch:
    use the correct "echo" when constructing the archive
  * d/config/pkg/* CONFIG_FEATURE_PATH_TRAVERSAL_PROTECTION=y
  * enable chattr and lsattr applets (Closes: #1119539)
  * udeb: install all links in /usr/, do not touch /bin & /sbin

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 31 Oct 2025 12:47:09 +0300

busybox (1:1.37.0-6) unstable; urgency=medium

  * udeb config: remove wget applet
    (wget-udeb is used for this for many years) (Closes: #1107392)

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 08 Jun 2025 00:34:24 +0300

busybox (1:1.37.0-5) unstable; urgency=medium

  * d/control: switch from Static-Built-Using back to Built-Using
    (Closes: #1106796)

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 30 May 2025 20:03:19 +0300

busybox (1:1.37.0-4) unstable; urgency=medium

  * d/control: use Static-Built-Using for busybox-static, not Built-Using
  * fix-od-and-hexdump-tests-on-big-endian-hosts.patch: v2
    (implement it a bit differently, fix bug in v1)

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 06 Oct 2024 14:30:47 +0300

busybox (1:1.37.0-3) unstable; urgency=medium

  * d/patches: +fix-od-and-hexdump-tests-on-big-endian-hosts.patch
    to fix tests failure on big-endian hosts

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 06 Oct 2024 13:35:45 +0300

busybox (1:1.37.0-2) unstable; urgency=medium

  * libbb-sha-add-missing-sha-NI-guard.patch - fix ftbfs on !x86

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 06 Oct 2024 11:09:29 +0300

busybox (1:1.37.0-1) unstable; urgency=medium

  * new upstream release 1.37.0
    Closes: CVE-2021-42380 (awk use-after-realloc)
    Cloese: CVE-2023-42363 (awk use-after-free)
  * d/patches/: refresh platform-linux.diff and version.patch
  * d/patches/: remove:
    - install-fix-chown-resetting-suid-sgid-bits-from-chmod.patch
    - syslogd-daemonize-after-init-make-errs-visible.patch
    - syslogd-decrease-stack-usage-50-bytes.patch
    - syslogd-fix-breakage-caused-by-daemonize-_after_-ini.patch
  * d/config/pkg/*: update configs:
    - enable time64
    - enable find exec-ok for regular and static builds
    - enable getfattr for regular and static builds
    - enable ip-link-can for regular and static builds
    - enable feature udhcpd bootp

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 06 Oct 2024 10:20:49 +0300

busybox (1:1.36.1-9) unstable; urgency=medium

  * platform-linux.diff: udhcpc6 also depends on PLATFORM_LINUX
    (fixes ftbfs on hurd)

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 16 Jul 2024 13:51:14 +0300

busybox (1:1.36.1-8) unstable; urgency=medium

  * busybox-1.36.1-no-cbq.patch to disable CBQ which is dropped
    from kernel in 6.8 (Closes: #1071648)

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 16 Jul 2024 13:03:13 +0300

busybox (1:1.36.1-7) unstable; urgency=medium

  * udeb: remove all modutils (kmod-udeb provides better alternatives)
    (Closes: #1060134)
  * deb, static, udeb: provide install applet (Closes: #1069864)
  * udhcpc/default.script: recognize $search dhcp parameter too,
    in addition to $domain (and simplify these parts a bit)

 -- Michael Tokarev <mjt@tls.msk.ru>  Thu, 16 May 2024 21:49:03 +0300

=== debian/control ===
Source: busybox
Priority: optional
Section: utils
Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders:
 Chris Boot <bootc@debian.org>,
 Christoph Biedl <debian.axhn@manchmal.in-ulm.de>,
 Michael Tokarev <mjt@tls.msk.ru>,
Build-Depends: debhelper-compat (= 13),
 zip <!nocheck>
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/installer-team/busybox.git
Vcs-Browser: https://salsa.debian.org/installer-team/busybox
Homepage: http://www.busybox.net
Rules-Requires-Root: no

Package: busybox
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: busybox-static
Replaces: busybox-static
Description: Tiny utilities for small and embedded systems
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.). The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 This package installs the BusyBox binary but does not install
 symlinks for any of the supported utilities. Some of the utilities
 can be used in the system by installing the busybox-syslogd,
 udhcpc or udhcpd packages.

Package: busybox-static
Architecture: any
Built-Using: ${built-using}
Depends: ${misc:Depends}
Conflicts: busybox
Replaces: busybox
Provides: busybox
Section: shells
Description: Standalone rescue shell with tons of builtin utilities
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.).  The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 busybox-static provides you with a statically linked simple stand alone shell
 that provides all the utilities available in BusyBox. This package is
 intended to be used as a rescue shell, in the event that you screw up your
 system. Invoke "busybox sh" and you have a standalone shell ready to save
 your system from certain destruction. Invoke "busybox", and it will list the
 available builtin commands.

Package: busybox-udeb
Package-Type: udeb
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Section: debian-installer
Description: Tiny utilities for the debian-installer
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.). The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 busybox-udeb is used by the debian-installer, so unless you are working on
 the debian-installer, this package is not for you. Installing this
 on your Debian system is a very, very bad idea. You have been warned.

Package: busybox-syslogd
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends:
 busybox (>> ${source:Upstream-Version}) | busybox-static (>> ${source:Upstream-Version}),
 ${misc:Depends},
Provides: linux-kernel-log-daemon, system-log-daemon
Conflicts: linux-kernel-log-daemon, system-log-daemon
Description: Provides syslogd and klogd using busybox
 The system log daemon is responsible for providing logging of
 messages received from programs and facilities on the local host as
 well as from remote hosts.
 .
 The kernel log daemon listens to kernel message sources and is
 responsible for prioritizing and processing operating system
 messages.
 .
 The busybox implementation of the syslogd is particular useful on
 embedded, diskless (netboot) or flash disk based systems because it
 can use a fixed size ring buffer for logging instead of saving logs
 to the disk or sending it to remote logging servers. The ring buffer
 can be read using the (also busybox based) command logread.
 .
 This package provides the glue to the busybox syslogd and klogd to be
 used in the system by providing the appropriate symbolic links and
 scripts.

Package: udhcpc
Section: net
# busybox dhcpc is linux-specific
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends:
 busybox (>> ${source:Upstream-Version}) | busybox-static (>> ${source:Upstream-Version}),
 ${misc:Depends},
Description: Provides the busybox DHCP client implementation
 Busybox contains a very small yet fully functional RFC compliant DHCP
 client udhcpc.
 .
 This package contains the glue to use the busybox udhcpc as DHCP
 client in the system by providing the appropriate symbolic links and
 scripts.

Package: udhcpd
Section: net
# busybox dhcpd is linux-specific
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends:
 busybox (>> ${source:Upstream-Version}) | busybox-static (>> ${source:Upstream-Version}),
 ${misc:Depends},
Provides: dhcpd
Description: Provides the busybox DHCP server implementation
 Busybox contains a very small yet fully function RFC compliant DHCP
 server udhcpd.
 .
 This package contains the glue to use the busybox udhcpd as DHCP
 server in the system by providing the appropriate symbolic links and
 scripts.

=== debian/rules ===
#!/usr/bin/make -f
SHELL = /bin/sh -e

# in order to keep output non-intermixed together, disable parallel building
# of different targets in this d/rules but allow running parallel submakes
.NOTPARALLEL:
# DEB_BUILD_OPTIONS=parallel=N
MAKEFLAGS += $(subst parallel=,-j,$(filter parallel=%,${DEB_BUILD_OPTIONS}))

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
V = $(if $(filter terse, ${DEB_BUILD_OPTIONS}),,1)

# Activate full hardening build flags
export DEB_BUILD_MAINT_OPTIONS := hardening=+all
# Fast version of dpkg/architecture.mk defining all vars in one go
ifeq (${DEB_HOST_MULTIARCH},)
   $(foreach d, $(shell dpkg-architecture | sed 's/=/?=/'), $(eval export $d))
endif
include /usr/share/dpkg/default.mk

##############################################################################

TESTSUITE_ENV = SKIP_KNOWN_BUGS=y
#TESTSUITE_ENV = VERBOSE=y
# always run tests in UTF8 mode to verify unicode support
TESTSUITE_ENV += LANG=C.UTF-8 LC_ALL=C.UTF-8
TESTSUITE_ENV += SKIP_INTERNET_TESTS=y
# Required for testsuite/taskset.tests
TESTSUITE_ENV += SHELL='${SHELL}'
# dash echo does not understand -e, bb builds its own in this case
TESTSUITE_ENV += ECHO=/bin/echo

# build directory
b = b

# which flavours to build
flavours = deb static udeb

ifneq (${DEB_HOST_GNU_TYPE},${DEB_BUILD_GNU_TYPE})
export CROSS_COMPILE = ${DEB_HOST_GNU_TYPE}-
endif

# We filter the following from CFLAGS:
# -O2
#   to use the optimization setting from busybox's configuration and build
#   system, causing it to use -Os. This reduces built binaries' size
#   considerably, making it easier to fit on space constrained systems.
CFLAGS := $(filter-out -O2, ${CFLAGS})

# Avoid Kconfig outputting the timestamp into generated configuration files. We
# use this to compare against the configuration files in debian/config/pkg for
# builds on Linux so that we can detect upstream configuration changes (e.g.
# added applets).
export KCONFIG_NOTIMESTAMP=1

install-indep install-arch install \
binary-indep binary-arch binary \
: %:
	dh $@

##############################################################################

configure: $(patsubst %,$b/%/.stamp-setup, ${flavours})
$(addprefix configure-,${flavours}): configure-%: $b/%/.stamp-setup
.PHONY: configure $(addprefix configure-,${flavours})

$b/%/.stamp-setup: d = $b/$*
$b/%/.stamp-setup:
	rm -rf $d
	mkdir -p $d

# Generate the .config file. First variable assignment wins.
# Several steps..

# 1, put any arch-specific overrides so they will have higher precedence
# should be empty for linux
	cat debian/config/os/${DEB_HOST_ARCH_OS} > $d/.config

# 2, use the flavour-specific base config file.
	cat debian/config/pkg/$* >> $d/.config

# 3, sort out the result using oldconfig Kbuild machinery and generate Makefile
	yes "" | ${MAKE} -C $d -f "${CURDIR}/Makefile" KBUILD_SRC="${CURDIR}" silentoldconfig V=$V

# 4, on linux platform only, compare the re-generated config to the shipped
# config in the package in order to catch new/changed upstream options.
ifeq (linux,${DEB_HOST_ARCH_OS})
	diff -u debian/config/pkg/$* $d/.config
endif

	ln -s .config $@

##############################################################################

build-arch: $(patsubst %,$b/%/.stamp-build, ${flavours})
build: build-arch
$(addprefix build-,${flavours}): build-%: $b/%/.stamp-build
build-indep:
.PHONY: build build-arch build-indep $(addprefix build-,${flavours})

# busybox build procedure is very sensitive for (environment) variables, it will
# remake everything if CFLAGS or LD has changed between build and install phases
# (and install depends on build, so busybox will be rebuilt during install if
# any env var has changed).
# Another problem is that upstream build system (as of 1.35) can not take more
# than a single target to build when building in parallel, the build fails in
# this case.  So we can not ask it for `all install' for example.
# To work around this, we use the upstream makefile only at the build stage,
# providing all environment explicitly in a single place.
# And installing will be done without the help from upstream makefiles,
# based on the information in the generated busybox.links file.

$b/%/.stamp-build: d = $b/$*
$b/%/.stamp-build: $b/%/.stamp-setup
	${MAKE} -C $d all \
	 SKIP_STRIP=y \
	 BB_EXTRA_VERSION="${DEB_VENDOR} ${DEB_VERSION}" \
	 CONFIG_EXTRA_CFLAGS='${CFLAGS} ${CPPFLAGS}' \
	 CONFIG_EXTRA_LDFLAGS='${CFLAGS} ${LDFLAGS}' \
	 V=$V
	${MAKE} -C $d busybox.links
	ln -sf busybox $@

##############################################################################

build-arch: $(if $(filter nocheck,${DEB_BUILD_OPTIONS}),,test-deb)
$(addprefix test-,${flavours}): test-%: $b/%/.stamp-test
.PHONY: $(addprefix test-,${flavours})

$b/%/.stamp-test: d = $b/$*
$b/%/.stamp-test: $b/%/.stamp-build
	@echo ======== running testsuite in $d ========
	@if [ ! -f $d/testsuite/.setup ]; then \
	    rm  -rf $d/testsuite ; \
	    cp -al testsuite $d/ ; \
	    rm -f $d/testsuite/mdev.tests; \
	    [ ! -f debian/testsuite-${DEB_HOST_ARCH_OS}.diff ] || \
		patch -p1 -d $d/ \
		  < debian/testsuite-${DEB_HOST_ARCH_OS}.diff ; \
	    touch $d/testsuite/.setup ; \
	fi
	cd $d/testsuite && ${TESTSUITE_ENV} ./runtest
	touch $@

##############################################################################

clean:
	dh_clean $b/
	rm -f .kernelrelease # leftover from the build process
.PHONY: clean

##############################################################################

override_dh_auto_install:

execute_after_dh_link-arch:
# for udeb we also need links. But we can not easily use `make install'
# (see comment above). So we run the install rules directly here:
	dh_link -pbusybox-udeb \
	  $$(grep -v sbin/init $b/udeb/busybox.links | \
	     sed -e 's|/usr/|/|' -e 's|^|/usr/bin/busybox /usr|')

execute_before_dh_gencontrol-arch:
# after shlibdeps finished, grab ${shlibs:Depends} from busybox package
# and transform it into Built-Using field (also dpkg-query bug #588505)
	pkgs=$$(sed -n -e's/([^)]*)//g' -e's/,//g' -e's/^shlibs:Depends=//p' debian/busybox.substvars); \
	srcs=; for p in $$pkgs; do \
	  srcs="$$srcs $$(dpkg-query -f '$${source:Package} (= $${source:Version}),' -W $$p)"; \
	done ; \
	echo "built-using=$$srcs" >> debian/busybox-static.substvars

# install busybox-klogd startup scripts
execute_before_dh_installinit:
	dh_installinit -pbusybox-syslogd --name=busybox-klogd
override_dh_installsystemd:
# explicitly list all packages with .service files here
	dh_installsystemd -pbusybox-syslogd --name=busybox-klogd
	dh_installsystemd -pbusybox-syslogd
	dh_installsystemd -pudhcpd --no-enable

## busybox 20041102-8.6embed1

=== debian/changelog ===
busybox (2:20041102-8.6) unstable; urgency=low

  * add which

 -- Riku Voipio <ext-riku.voipio@nokia.com>  Tue, 19 Apr 2005 17:01:16 +0300

busybox (2:20041102-8.5) unstable; urgency=low

  * oops, not so fast. the previous one did not fix tar yet

 -- Riku Voipio <ext-riku.voipio@nokia.com>  Tue, 19 Apr 2005 16:31:52 +0300

busybox (2:20041102-8.4) unstable; urgency=low

  * fix exec for debconf
  * add dummy -m to tar

 -- Riku Voipio <ext-riku.voipio@nokia.com>  Tue, 19 Apr 2005 16:06:32 +0300

busybox (2:20041102-8.3) unstable; urgency=low

  * Add rmmod applet

 -- Riku Voipio <ext-riku.voipio@nokia.com>  Mon, 11 Apr 2005 16:31:08 +0300

busybox (2:20041102-8.2) unstable; urgency=low

  * fix numeric test

 -- Riku Voipio <ext-riku.voipio@nokia.com>  Mon, 11 Apr 2005 10:56:58 +0300

busybox (2:20041102-8.1) unstable; urgency=low

  * re-apply performance fixes
  * fix pointers to builtin table
  * Add dbg package

 -- Riku Voipio <ext-riku.voipio@nokia.com>  Tue,  5 Apr 2005 15:29:36 +0300

busybox (2:20041102-8) unstable; urgency=low

  * map '[' as builtin (from celf)
  * Fix postrm

 -- Riku Voipio <ext-riku.voipio@nokia.com>  Fri, 18 Mar 2005 15:32:20 +0200

busybox (2:20041102-7) unstable; urgency=low

  * fix umount -l
  * performance optimisations

 -- Riku Voipio <ext-riku.voipio@nokia.com>  Fri, 18 Mar 2005 13:39:40 +0200

busybox (2:20041102-6) unstable; urgency=low

  * Drop e2fsprogs

 -- Riku Voipio <ext-riku.voipio@nokia.com>  Tue, 15 Mar 2005 11:42:04 +0200

busybox (2:20041102-5) unstable; urgency=low

  * Add missing util-linux r/d/c
  * Add some features users might want (like tab completetion)

 -- Riku Voipio <ext-riku.voipio@nokia.com>  Mon, 14 Mar 2005 20:39:30 +0200

busybox (2:20041102-4) unstable; urgency=low

  * Drop debianutils virtual package

 -- Riku Voipio <ext-riku.voipio@nokia.com>  Mon, 14 Mar 2005 15:39:44 +0200

busybox (2:20041102-3) unstable; urgency=low

  * Less virtual packages.
  * remove unneeded applets
  * TODO: profile applets that should be made ash builtins

 -- Riku Voipio <ext-riku.voipio@nokia.com>  Fri, 25 Feb 2005 15:20:16 +0200

busybox (2:20041102-2) unstable; urgency=low

  * Add epoch and virtual packages
  * source alias for "." in ash
  * added busybox startup script

 -- Riku Voipio <ext-riku.voipio@nokia.com>  Tue, 30 Nov 2004 18:56:34 +0200

busybox (20041102-1) unstable; urgency=low

  * New upstream (busybox 1.0)
  * Overtake the control from the bloated GNU

 -- Riku Voipio <ext-riku.voipio@nokia.com>  Tue,  2 Nov 2004 15:21:25 +0200

=== debian/control ===
Source: busybox
Priority: optional
Section: base
Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders: Erik Andersen <andersee@debian.org>, Bastian Blank <waldi@debian.org>
Build-Depends: debhelper (>= 4.0.0)
Standards-Version: 3.6.1

Package: busybox
Architecture: any
Depends: ${shlibs:Depends}
Provides:  busybox-static, busybox, busybox-static, findutils,gzip,hostname,ifupdown,module-init-tools,net-tools,procps,sed,tar,coreutils,grep,mount,login, bash, debianutils, util-linux
Replaces:  busybox-static, busybox, busybox-static, findutils,gzip,hostname,ifupdown,module-init-tools,net-tools,procps,sed,tar,coreutils,grep,mount,login, bash, debianutils, util-linux
Conflicts: busybox-static, busybox, busybox-static, findutils,gzip,hostname,ifupdown,module-init-tools,net-tools,procps,sed,tar,coreutils,grep,mount,login, debianutils, util-linux
Section: utils
Description: Tiny utilities for small and embedded systems
 BusyBox combines tiny versions of many common UNIX utilities into a single
 small executable. It provides minimalist replacements for the most common
 utilities you would usually find on your desktop system (i.e., ls, cp, mv,
 mount, tar, etc.). The utilities in BusyBox generally have fewer options than
 their full-featured GNU cousins; however, the options that are included
 provide the expected functionality and behave very much like their GNU
 counterparts.
 .
 This package installs the BusyBox binary but does not install symlinks
 for any of the supported utilities. You can use /bin/busybox --install
 to install BusyBox to the current directory (you do not want to do this
 in / on your Debian system!).

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_GNU_SYSTEM ?= $(shell dpkg-architecture -qDEB_HOST_GNU_SYSTEM)

VERSION = $(shell dpkg-parsechangelog | grep ^Version: | cut -d ' ' -f 2)
EXTRA_VERSION = Debian $(VERSION)

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CONFIG_DEBUG = true
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
endif

export EXTRA_VERSION CONFIG_DEBUG

PACKAGE_PREFIX = busybox

PACKAGES_DEB = $(PACKAGE_PREFIX) 

DEBHELPER_PACKAGES_DEB = $(patsubst %,-p%,$(PACKAGES_DEB))

CONFIG = $(firstword $(wildcard ./debian/config-$(1)-$(DEB_HOST_GNU_SYSTEM)-$(DEB_HOST_GNU_CPU) ./debian/config-$(1)-$(DEB_HOST_GNU_SYSTEM) ./debian/config-$(1)))
CONFIG_DEB = $(call CONFIG,deb)

build-arch: build-arch-deb

.NOTPARALLEL: build-arch-deb build-arch-static build-arch-udeb build-arch-floppy-udeb

build-arch-deb: build-arch-deb-stamp
build-arch-deb-stamp: 
	$(MAKE) clean

	cp $(CONFIG_DEB) .config

	$(MAKE) dep
	$(MAKE)

	install -d \
		install-$(PACKAGE_PREFIX)/bin \
		install-$(PACKAGE_PREFIX)/usr/share/man/man1
	install busybox install-$(PACKAGE_PREFIX)/bin/busybox
	install docs/BusyBox.1 install-$(PACKAGE_PREFIX)/usr/share/man/man1/busybox.1

	touch $@

build: build-arch

clean:
	dh_testdir
	dh_testroot
	rm -f build-*-stamp

	-$(MAKE) distclean
	-rm -rf install* busybox.1
	-rm -f debian/busybox.links

	dh_clean

install-deb: build-arch-deb
	dh_testdir
	dh_testroot
	dh_clean -k $(DEBHELPER_PACKAGES_DEB)
	dh_installdirs $(DEBHELPER_PACKAGES_DEB)

	for i in $(PACKAGES_DEB); do \
	( \
		cd install-$$i; \
		find -type d -exec install -d $(CURDIR)/debian/$$i/{} \;; \
		find \( -type f -o -type l \) -exec cp -a {} $(CURDIR)/debian/$$i/{} \;; \
	); \
	done

	sed -e 's,^/,bin/busybox ,' busybox.links | grep -v linuxrc >  debian/busybox.links

	#install -m644 debian/$(PACKAGE_PREFIX)-static.override \
	#	debian/$(PACKAGE_PREFIX)-static/usr/share/lintian/overrides/$(PACKAGE_PREFIX)-static

binary-arch: binary-arch-deb

# Build architecture-dependent files here.
binary-arch-deb: build-arch-deb install-deb
	dh_testdir
	dh_testroot
	#install debian/local/bash debian/busybox/bin/bash
	install debian/local/faketrue debian/busybox/sbin/update-modules
	dh_installinit -n $(DEBHELPER_PACKAGES_DEB)
	dh_installdocs $(DEBHELPER_PACKAGES_DEB)
	dh_installchangelogs Changelog $(DEBHELPER_PACKAGES_DEB)
	dh_strip $(DEBHELPER_PACKAGES_DEB)
	dh_link $(DEBHELPER_PACKAGES_DEB)
	dh_compress $(DEBHELPER_PACKAGES_DEB)
	dh_fixperms $(DEBHELPER_PACKAGES_DEB)
	dh_installdeb $(DEBHELPER_PACKAGES_DEB)
	dh_shlibdeps $(DEBHELPER_PACKAGES_DEB)
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## busybox 20041102-11

=== debian/changelog ===
busybox (2:20041102-11) unstable; urgency=low

  * Add logger to log from syslog

 -- Riku Voipio <ext-riku.voipio@nokia.com>  Fri,  9 Sep 2005 15:38:23 +0300

busybox (2:20041102-10) unstable; urgency=low

  * Fix infamous ö bug
  * sleep builting
  * Debug release to identify which bb commands are most used

 -- Riku Voipio <ext-riku.voipio@nokia.com>  Tue,  6 Sep 2005 10:25:47 +0300

busybox (2:20041102-9) unstable; urgency=low

  * add chvt (closes: #18427)
  * add stty/reset/clean and mkswap on popular requests
  * fix ps column header (closes: #18044)

 -- Riku Voipio <ext-riku.voipio@nokia.com>  Mon,  5 Sep 2005 09:55:50 +0300

## busybox 20041102-11sdk1

=== debian/changelog ===
busybox (2:20041102-11sdk1) unstable; urgency=low

  * Added vi, ping and traceroute to build

 -- Riku Voipio <ext-riku.voipio@nokia.com>  Tue, 18 Oct 2005 16:43:39 +0300
